/// <reference types="node" />
import { AddressInfo } from 'net';
import { patternOf } from '@tech_query/node-toolkit';
export default class WebServer {
    staticPath?: string;
    netPort?: number;
    XDomain?: boolean;
    openPath?: boolean | string;
    address?: AddressInfo;
    private core;
    private proxyMap;
    constructor({ proxyMap, ...rest }?: {
        staticPath?: string;
        netPort?: number;
        XDomain?: boolean;
        openPath?: boolean | string;
        proxyMap?: Parameters<typeof patternOf>[0];
    });
    private boot;
    /**
     * Origin URI
     */
    get URL(): string;
    /**
     * URL to open in default browser
     */
    get openURL(): string;
    static getIPA(): {
        family: string;
        address: string;
    };
    /**
     * Create a server in the same Node.JS process
     */
    localHost(): import("http").Server;
    /**
     * Boot a server in a forked Node.JS process
     */
    workerHost(): Promise<AddressInfo>;
}
